#include "TBod.h"

int TBod::iLiving=0;

int TBod::Living()
	{
	return(iLiving);
	}

TBod::TBod(char aRetez[])
	{
	char c;
	istringstream iss(aRetez, istringstream::in);
	iss >> c;
	iss >> iX;
	iss >> c;
	iss >> iY;
	iss >> c;
	iss >> iZ;
	iLiving++;
	}

TBod::TBod()
	{
	iX = iY = iZ = 0.0;
	iLiving++;
	}

TBod::TBod(double aX, double aY, double aZ)
	{
	iX = aX;
	iY = aY;
	iZ = aZ;
	iLiving++;
	}

TBod::TBod(const TBod &aBod)
	{
	iX = aBod.iX;
	iY = aBod.iY;
	iZ = aBod.iZ;
	iLiving++;
	}

TBod::~TBod()
	{
	iX = iY = iZ = 0.0;
	iLiving--;
	}

TBod TBod::operator+(const TBod &aHodnotaP) const
	{
	TBod Vysl(aHodnotaP);
	Vysl.iX += iX;
	Vysl.iY += iY;
	Vysl.iZ += iZ;
/*
	TBod Vysl(*this);
	Vysl.iX += aHodnotaP.iX;
	Vysl.iY += aHodnotaP.iY;
	Vysl.iZ += aHodnotaP.iZ;
*/
	return(Vysl);
	}

TBod& TBod::operator+=(const TBod &aHodnotaP)
	{
	iX += aHodnotaP.iX;
	iY += aHodnotaP.iY;
	iZ += aHodnotaP.iZ;
	return(*this);
	}

TBod& TBod::operator=(const TBod &aHodnotaP)
	{
	if(this != &aHodnotaP)  // kdyz jsou jednotlive slozky dynamicky alokovane je potreba kontrolovat
		{
		iX = aHodnotaP.iX;
		iY = aHodnotaP.iY;
		iZ = aHodnotaP.iZ;
		}
	return(*this);
	}


TBod operator*(const int aHodnotaL,const TBod &aHodnotaP)
	{
	TBod Vysl(aHodnotaP);
	Vysl.iX *= double(aHodnotaL);
	Vysl.iY *= double(aHodnotaL);
	Vysl.iZ *= double(aHodnotaL);
	return Vysl;
	}

double TBod::Delka() const
	{
	return(sqrt(iX*iX + iY*iY + iZ*iZ));
	}

double TBod::Vzdalenost() const
	{
	return(Delka());
	}

TBod Vzdalenost(const TBod &aHodnotaL, const TBod &aHodnotaP)
	{
/*
	TBod Vysl(aHodnotaP);
	Vysl.iX -=aHodnotaL.iX;
	Vysl.iY -=aHodnotaL.iY;
	Vysl.iZ -=aHodnotaL.iZ;
	return(Vysl);
*/
	return(TBod( aHodnotaP.iX - aHodnotaL.iX,
		         aHodnotaP.iY - aHodnotaL.iY, 
		         aHodnotaP.iZ - aHodnotaL.iZ
		       )
		  );
	}

TBod::operator double() const
	{
	return(Vzdalenost());
	}

ostream& operator<<(ostream& aStream, const TBod& aBod)
	{
	aStream << '[';
	aStream << aBod.iX << ',';
	aStream << aBod.iY << ',';
	aStream << aBod.iZ << ']';
	return aStream;
	}
